---
title: HTMLCanvasElement.captureStream()
slug: Web/API/HTMLCanvasElement/captureStream
tags:
  - Canvas
  - Experimental
  - Frame Capture
  - HTMLCanvasElement
  - Interface
  - Media
  - Media Capture DOM Elements
  - Method
  - Reference
  - Web
  - captureStream
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The {{domxref("HTMLCanvasElement")}} <strong><code>captureStream()</code></strong> method returns a {{domxref("MediaStream")}} which includes a {{domxref("CanvasCaptureMediaStreamTrack")}} containing a real-time video capture of the canvas's contents.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>MediaStream</var> = <var>canvas</var>.captureStream(<var>frameRate</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>frameRate</code> {{optional_inline}}</dt>
 <dd>A double-precision floating-point value that indicates the rate of capture of each frame. If not set, a new frame will be captured each time the canvas changes; if set to <code>0</code>, frames will not be captured automatically; instead, they will only be captured when the returned track's {{domxref("CanvasCaptureMediaStreamTrack.requestFrame", "requestFrame()")}} method is called.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A reference to a {{domxref("MediaStream")}} object, which has a single {{domxref("CanvasCaptureMediaStreamTrack")}} in it.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>NotSupportedError</code></dt>
 <dd>The value of <code>frameRate</code> is negative.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">// Find the canvas element to capture
var canvasElt = document.querySelector('canvas');

// Get the stream
var stream = canvasElt.captureStream(25); // 25 FPS

// Do things to the stream
// E.g. Send it to another computer using an RTCPeerConnection
//      pc is an RTCPeerConnection created elsewhere
pc.addStream(stream);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Media Capture DOM Elements', '#dom-htmlcanvaselement-capturestream', 'HTMLCanvasElement.captureStream()')}}</td>
   <td>{{Spec2('Media Capture DOM Elements')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLCanvasElement.captureStream")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("HTMLMediaElement.captureStream()")}}, which allows capturing a stream from a media element.</li>
 <li>{{domxref("MediaStream")}}</li>
 <li>{{domxref("Media Capture and Streams API")}}</li>
</ul>
